]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
Festplattenerkennung ueberarbeitet.
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0b" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|light|voice|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j4"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 net-tools
302 lfsmake2 patch
303 lfsmake2 psmisc
304 lfsmake2 reiser4progs
305 lfsmake2 shadow
306 lfsmake2 sysklogd
307 lfsmake2 sysvinit
308 lfsmake2 tar
309 lfsmake2 texinfo
310 lfsmake2 udev
311 lfsmake2 util-linux
312 lfsmake2 vim
313 lfsmake2 grub
314 }
315
316 buildipfire() {
317 LOGFILE="$BASEDIR/log/_build.ipfire.log"
318 export LOGFILE
319 ipfiremake configroot
320 ipfiremake dhcp
321 ipfiremake dhcpcd
322 ipfiremake libusb
323 ipfiremake libpcap
324 ipfiremake linux-atm
325 ipfiremake ppp
326 ipfiremake rp-pppoe
327 ipfiremake unzip
328 ipfiremake linux SMP=1
329 ipfiremake ipp2p SMP=1
330 ipfiremake fcdsl SMP=1
331 ipfiremake fcdsl2 SMP=1
332 ipfiremake fcdslsl SMP=1
333 ipfiremake fcdslusb SMP=1
334 ipfiremake fcdslslusb SMP=1
335 ipfiremake fcpci SMP=1
336 # ipfiremake promise-sata-300-tx SMP=1
337 ipfiremake zaptel SMP=1
338 ipfiremake fuse SMP=1
339 ipfiremake linux
340 ipfiremake ipp2p
341 ipfiremake fcdsl
342 ipfiremake fcdsl2
343 ipfiremake fcdslsl
344 ipfiremake fcdslusb
345 ipfiremake fcdslslusb
346 ipfiremake fcpci
347 # ipfiremake promise-sata-300-tx
348 ipfiremake zaptel
349 ipfiremake fuse
350 ipfiremake pkg-config
351 ipfiremake cpio
352 ipfiremake expat
353 ipfiremake gdbm
354 ipfiremake gmp
355 ipfiremake pam
356 ipfiremake openssl
357 ipfiremake python
358 ipfiremake libnet
359 ipfiremake libjpeg
360 ipfiremake libpng
361 ipfiremake libtiff
362 ipfiremake lcms
363 ipfiremake libmng
364 ipfiremake freetype
365 ipfiremake libart
366 ipfiremake gd
367 ipfiremake popt
368 ipfiremake pcre
369 ipfiremake slang
370 ipfiremake newt
371 ipfiremake libcap
372 ipfiremake pciutils
373 ipfiremake libxml2
374 ipfiremake BerkeleyDB
375 ipfiremake mysql
376 ipfiremake cyrus-sasl
377 ipfiremake openldap
378 ipfiremake apache2
379 ipfiremake php
380 ipfiremake apache2 PASS=C
381 ipfiremake arping
382 ipfiremake beep
383 ipfiremake bind
384 ipfiremake capi4k-utils
385 ipfiremake cdrtools
386 ipfiremake dnsmasq
387 ipfiremake libaal
388 ipfiremake dosfstools
389 ipfiremake reiserfsprogs
390 ipfiremake squashfstools
391 ipfiremake sysfsutils
392 ipfiremake ntfs-3g
393 ipfiremake ethtool
394 ipfiremake ez-ipupdate
395 ipfiremake fcron
396 ipfiremake GD
397 ipfiremake GD-Graph
398 ipfiremake GD-TextUtil
399 ipfiremake gnupg
400 ipfiremake hdparm
401 ipfiremake ibod
402 ipfiremake initscripts
403 ipfiremake whatmask
404 ipfiremake iptables
405 ipfiremake libupnp
406 ipfiremake ipp2p IPT=1
407 ipfiremake moblock
408 ipfiremake linux-igd
409 ipfiremake ipac-ng
410 ipfiremake ipaddr
411 ipfiremake iptstate
412 ipfiremake iputils
413 ipfiremake l7-protocols
414 ipfiremake isapnptools
415 # ipfiremake isdn4k-utils # What about mISDN???
416 ipfiremake hwdata
417 ipfiremake kudzu
418 ipfiremake logrotate
419 ipfiremake logwatch
420 ipfiremake misc-progs
421 ipfiremake mtools
422 ipfiremake nano
423 ipfiremake nash
424 ipfiremake nasm
425 ipfiremake URI
426 ipfiremake HTML-Tagset
427 ipfiremake HTML-Parser
428 ipfiremake Compress-Zlib
429 ipfiremake Digest
430 ipfiremake Digest-SHA1
431 ipfiremake Digest-HMAC
432 ipfiremake libwww-perl
433 ipfiremake Net-DNS
434 ipfiremake Net-IPv4Addr
435 ipfiremake Net_SSLeay
436 ipfiremake IO-Stringy
437 ipfiremake Unix-Syslog
438 ipfiremake Mail-Tools
439 ipfiremake MIME-Tools
440 ipfiremake Net-Server
441 ipfiremake Convert-TNEF
442 ipfiremake Convert-UUlib
443 ipfiremake Archive-Tar
444 ipfiremake Archive-Zip
445 ipfiremake Text-Tabs+Wrap
446 ipfiremake Locale-Country
447 ipfiremake XML-Parser
448 ipfiremake glib
449 ipfiremake dbus
450 ipfiremake hal
451 ipfiremake hwinfo
452 ipfiremake GeoIP
453 ipfiremake fwhits
454 ipfiremake noip_updater
455 ipfiremake ntp
456 ipfiremake oinkmaster
457 ipfiremake openssh
458 ipfiremake openswan
459 ipfiremake pptpclient
460 ipfiremake rrdtool
461 ipfiremake setserial
462 ipfiremake setup
463 ipfiremake snort
464 ipfiremake squid
465 ipfiremake squid-graph
466 ipfiremake squidguard
467 ipfiremake tcpdump
468 ipfiremake traceroute
469 ipfiremake vlan
470 ipfiremake wireless
471 ipfiremake libsafe
472 ipfiremake 3c5x9setup
473 ipfiremake pakfire
474 ipfiremake java
475 ipfiremake bootsplash
476 ipfiremake spandsp
477 ipfiremake lzo
478 ipfiremake openvpn
479 ipfiremake pammysql
480 ipfiremake xinetd
481 ipfiremake ghostscript
482 ipfiremake cups
483 ipfiremake samba
484 ipfiremake sudo
485 ipfiremake mc
486 ipfiremake wget
487 ipfiremake wput
488 ipfiremake bridge-utils
489 ipfiremake screen
490 ipfiremake hddtemp
491 ipfiremake smartmontools
492 ipfiremake htop
493 ipfiremake lynx
494 ipfiremake postfix
495 ipfiremake procmail
496 ipfiremake fetchmail
497 ipfiremake cyrusimap
498 ipfiremake webcyradm
499 ipfiremake mailx
500 ipfiremake clamav
501 ipfiremake razor
502 ipfiremake spamassassin
503 ipfiremake amavisd
504 ipfiremake stund
505 ipfiremake libpri
506 # ipfiremake bristuff
507 ipfiremake asterisk
508 ipfiremake mpg123
509 ipfiremake libmad
510 ipfiremake libogg
511 ipfiremake libvorbis
512 ipfiremake lame
513 ipfiremake xvid
514 ipfiremake mpeg2dec
515 ipfiremake ffmpeg
516 ipfiremake sox
517 ipfiremake gnump3d
518 ipfiremake videolan
519 ipfiremake applejuice
520 ipfiremake ocaml
521 ipfiremake mldonkey
522 ipfiremake ntop
523 ipfiremake rsync
524 ipfiremake tcpwrapper
525 ipfiremake portmap
526 ipfiremake nfs
527 ipfiremake nmap
528 ipfiremake mbmon
529 ipfiremake iftop
530 ipfiremake ncftp
531 ipfiremake cftp
532 ipfiremake etherwake
533 ipfiremake ethereal
534 ipfiremake tftp-hpa
535 ipfiremake iptraf
536 ipfiremake bwm-ng
537 ipfiremake nagios
538 ipfiremake tripwire
539 ipfiremake sysstat
540 }
541
542 buildinstaller() {
543 # Run installer scripts one by one
544 LOGFILE="$BASEDIR/log/_build.installer.log"
545 export LOGFILE
546 ipfiremake syslinux
547 ipfiremake as86
548 ipfiremake mbr
549 ipfiremake memtest
550 installmake linux-libc-header
551 installmake binutils
552 ipfiremake uClibc PASS=1
553 ipfiremake gcc INST=1
554 installmake uClibc PASS=2
555 installmake gcc INST=2
556 installmake uClibc PASS=3
557 installmake busybox
558 installmake udev
559 installmake slang
560 installmake newt
561 installmake gettext
562 installmake kbd
563 installmake popt
564 installmake sysvinit
565 installmake misc-progs
566 installmake e2fsprogs
567 installmake libaal
568 installmake reiser4progs
569 installmake reiserfsprogs
570 installmake sysfsutils
571 installmake util-linux
572 installmake pciutils
573 installmake zlib
574 installmake wget
575 installmake libxml2
576 installmake dbus
577 installmake hal
578 installmake hwdata
579 installmake hwinfo
580 installmake kudzu
581 installmake installer
582 installmake initrd
583 }
584
585 buildpackages() {
586 LOGFILE="$BASEDIR/log/_build.packages.log"
587 export LOGFILE
588 echo "... see detailed log in _build.*.log files" >> $LOGFILE
589
590 installmake strip
591
592 # Generating list of packages used
593 echo -n "Generating packages list from logs" | tee -a $LOGFILE
594 rm -f $BASEDIR/doc/packages-list
595 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
596 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
597 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
598 fi
599 done
600 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
601 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
602 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
603 rm -f $BASEDIR/doc/packages-list
604 # packages-list.txt is ready to be displayed for wiki page
605 beautify message DONE
606
607 # Create images for install
608 if [ "$DEVEL" == "1" ]; then
609 ipfiremake cdrom ED=devel
610 fi
611 ipfiremake cdrom ED=full
612
613 # Check if there is a loop device for building in virtual environments
614 if [ -e /dev/loop0 ]; then
615 ipfiremake usb-stick
616 fi
617 ipfiremake pxe
618 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
619
620 # ipfirepackages
621
622 # Cleanup
623 stdumount
624 rm -rf $BASEDIR/build/tmp/*
625
626 # Generating total list of files
627 echo "Generating files list from logs" | tee -a $LOGFILE
628 rm -f $BASEDIR/log/FILES
629 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
630 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
631 echo "##" >>$BASEDIR/log/FILES
632 echo "## `basename $i`" >>$BASEDIR/log/FILES
633 echo "##" >>$BASEDIR/log/FILES
634 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
635 fi
636 done
637 cd $BASEDIR/packages; ls -w1 *.ipfire | awk -F ".ipfire" '{ print $1 }' > $BASEDIR/packages/packages_list.txt
638 echo -n "###EOF###" >> $BASEDIR/packages/packages_list.txt
639
640 cd $PWD
641 }
642
643 ipfirepackages() {
644 if [ -d "$BASEDIR/packages" ]; then
645 for i in `ls $BASEDIR/packages`; do
646 touch $BASEDIR/build/install/packages/$i.empty
647 done
648 fi
649 # ipfiredist amavisd
650 ipfiredist applejuice
651 ipfiredist asterisk
652 ipfiredist clamav
653 ipfiredist cups
654 ipfiredist cyrusimap
655 ipfiredist fetchmail
656 ipfiredist ffmpeg
657 ipfiredist gnump3d
658 ipfiredist iptraf
659 ipfiredist java
660 ipfiredist lame
661 ipfiredist libmad
662 ipfiredist libogg
663 ipfiredist libvorbis
664 ipfiredist mailx
665 ipfiredist mldonkey
666 ipfiredist mpeg2dec
667 ipfiredist nagios
668 ipfiredist nfs
669 ipfiredist nmap
670 ipfiredist ntop
671 ipfiredist portmap
672 ipfiredist postfix
673 ipfiredist procmail
674 ipfiredist samba
675 ipfiredist sox
676 ipfiredist spamassassin
677 ipfiredist subversion
678 ipfiredist videolan
679 ipfiredist webcyradm
680 ipfiredist xvid
681 ipfiredist yasuc
682 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
683 mv -f $LFS/install/packages/*.{ipfire,md5} $BASEDIR/packages >> $LOGFILE 2>&1
684 rm -rf $BASEDIR/build/install/packages/*
685 }
686
687 # See what we're supposed to do
688 case "$1" in
689 build)
690 clear
691 BUILDMACHINE=`uname -m`
692 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
693 #only restore on a clean disk
694 if [ ! -f log/cleanup-toolchain-2-tools ]; then
695 if [ ! -n "$PACKAGE" ]; then
696 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
697 prepareenv
698 buildtoolchain
699 else
700 PACKAGENAME=${PACKAGE%.tar.gz}
701 beautify build_stage "Packaged toolchain compilation"
702 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
703 tar zxf $PACKAGE
704 prepareenv
705 else
706 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
707 fi
708 fi
709 else
710 echo -n "Using installed toolchain" | tee -a $LOGFILE
711 beautify message SKIP
712 prepareenv
713 fi
714
715 beautify build_start
716 beautify build_stage "Building LFS"
717 buildbase
718
719 beautify build_stage "Building IPFire"
720 buildipfire
721
722 # Setzen des IPFire Builds
723 if [ "$FIREBUILD" ]; then
724 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
725 else
726 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
727 fi
728
729 beautify build_stage "Building installer"
730 buildinstaller
731
732 beautify build_stage "Building packages"
733 buildpackages
734 beautify build_end
735 ;;
736 shell)
737 # enter a shell inside LFS chroot
738 # may be used to changed kernel settings
739 prepareenv
740 entershell
741 ;;
742 changelog)
743 echo -n "Loading new Changelog from SVN: "
744 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
745 beautify message DONE
746 ;;
747 clean)
748 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
749 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
750 $LOSETUP -d $i 2>/dev/null
751 done
752 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
753 umount $i
754 done
755 stdumount
756 for i in `seq 0 7`; do
757 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
758 umount /dev/loop${i} 2>/dev/null;
759 losetup -d /dev/loop${i} 2>/dev/null;
760 fi;
761 done
762 rm -rf $BASEDIR/build
763 rm -rf $BASEDIR/cdrom
764 rm -rf $BASEDIR/packages
765 rm -rf $BASEDIR/log
766 if [ -h /tools ]; then
767 rm -f /tools
768 fi
769 beautify message DONE
770 ;;
771 downloadsrc)
772 if [ ! -d $BASEDIR/cache ]; then
773 mkdir $BASEDIR/cache
774 fi
775 mkdir -p $BASEDIR/log
776 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
777 FINISHED=0
778 cd $BASEDIR/lfs
779 for c in `seq $MAX_RETRIES`; do
780 if (( FINISHED==1 )); then
781 break
782 fi
783 FINISHED=1
784 cd $BASEDIR/lfs
785 for i in *; do
786 if [ -f "$i" -a "$i" != "Config" ]; then
787 echo -ne "Loading $i"
788 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
789 if [ $? -ne 0 ]; then
790 beautify message FAIL
791 FINISHED=0
792 else
793 if [ $c -eq 1 ]; then
794 beautify message DONE
795 fi
796 fi
797 fi
798 done
799 done
800 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
801 ERROR=0
802 for i in *; do
803 if [ -f "$i" -a "$i" != "Config" ]; then
804 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
805 if [ $? -ne 0 ]; then
806 echo -ne "MD5 difference in lfs/$i"
807 beautify message FAIL
808 ERROR=1
809 fi
810 fi
811 done
812 if [ $ERROR -eq 0 ]; then
813 echo -ne "${BOLD}all files md5sum match${NORMAL}"
814 beautify message DONE
815 else
816 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
817 beautify message FAIL
818 fi
819 cd - >/dev/null 2>&1
820 ;;
821 toolchain)
822 clear
823 prepareenv
824 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
825 buildtoolchain
826 BUILDMACHINE=`uname -m`
827 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
828 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
829 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
830 build/{bin,etc,usr/bin,usr/local} \
831 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
832 log >> $LOGFILE
833 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
834 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
835 stdumount
836 ;;
837 gettoolchain)
838 BUILDMACHINE=`uname -m`
839 # arbitrary name to be updated in case of new toolchain package upload
840 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
841 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
842 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
843 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
844 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
845 cd $BASEDIR/cache/toolchains
846 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
847 if [ $? -ne 0 ]; then
848 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
849 else
850 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
851 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
852 else
853 exiterror "$PACKAGE.md5 did not match, check downloaded package"
854 fi
855 fi
856 else
857 echo "Toolchain is already downloaded. Exiting..."
858 fi
859 ;;
860 othersrc)
861 prepareenv
862 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
863 chroot $LFS /tools/bin/env -i HOME=/root \
864 TERM=$TERM PS1='\u:\w\$ ' \
865 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
866 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
867 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
868 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
869 if [ $? -eq "0" ]; then
870 beautify message DONE
871 else
872 beautify message FAIL
873 fi
874 stdumount
875 ;;
876 svn)
877 case "$2" in
878 update|up)
879 # clear
880 echo -ne "Loading the latest source files...\n"
881 if [ $3 ]; then
882 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
883 else
884 svn update | tee -a $PWD/log/_build.svn.update.log
885 fi
886 if [ $? -eq "0" ]; then
887 beautify message DONE
888 else
889 beautify message FAIL
890 exit 1
891 fi
892 echo -ne "Writing the svn-info to a file"
893 svn info > $PWD/svn_status
894 if [ $? -eq "0" ]; then
895 beautify message DONE
896 else
897 beautify message FAIL
898 exit 1
899 fi
900 chmod 755 $0
901 exit 0
902 ;;
903 commit|ci)
904 clear
905 if [ -f /usr/bin/mcedit ]; then
906 export EDITOR=/usr/bin/mcedit
907 fi
908 if [ -f /usr/bin/nano ]; then
909 export EDITOR=/usr/bin/nano
910 fi
911 echo -ne "Selecting editor $EDITOR..."
912 beautify message DONE
913 if [ -e /sbin/yast ]; then
914 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
915 $0 changelog
916 fi
917 fi
918 update_langs
919 svn commit
920 $0 svn up
921 if [ -n "$FTP_CACHE_URL" ]; then
922 $0 uploadsrc
923 fi
924 ;;
925 dist)
926 if [ $3 ]; then
927 SVN_REVISION=$3
928 fi
929 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
930 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
931 exit 0
932 fi
933 echo -en "REV $SVN_REVISION: Downloading..."
934 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
935 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
936 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
937 evaluate 1
938
939 echo -en "REV $SVN_REVISION: Compressing files..."
940 if [ -e ipfire-source/trunk/make.sh ]; then
941 chmod 755 ipfire-source/trunk/make.sh
942 fi
943 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
944 evaluate 1
945 echo -en "REV $SVN_REVISION: Cleaning up..."
946 rm ipfire-source/ -r
947 evaluate 1
948 ;;
949 diff|di)
950 update_langs
951 echo -ne "Make a local diff to last svn revision"
952 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
953 evaluate 1
954 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
955 svn status
956 ;;
957 esac
958 ;;
959 uploadsrc)
960 PWD=`pwd`
961 cd $BASEDIR/cache/
962 echo -e "Uploading cache to ftp server:"
963 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
964 for i in *; do
965 if [ "$i" == "toolchains" ]; then continue; fi
966 grep -q $i /tmp/ftplist
967 if [ "$?" -ne "0" ]; then
968 echo -ne "$i"
969 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
970 if [ "$?" -ne "0" ]; then
971 beautify message FAIL
972 fi
973 fi
974 done
975 rm -f /tmp/ftplist
976 cd $PWD
977 exit 0
978 ;;
979 upload)
980 case "$2" in
981 iso)
982 echo -e "Uploading the iso to $IPFIRE_FTP_URL_EXT."
983 cat <<EOF > .ftp-commands
984 mkdir $IPFIRE_FTP_PATH_EXT
985 ls -lah
986 quit
987 EOF
988 ncftp -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT < .ftp-commands
989 rm -f .ftp-commands
990 md5sum ipfire-install-$VERSION.i386.iso > ipfire-install-$VERSION.i386.iso.md5
991 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso
992 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso.md5
993 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-source-r$SVN_REVISION.tar.gz
994 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ svn_status
995 if [ "$?" -eq "0" ]; then
996 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $IPFIRE_FTP_URL_EXT$IPFIRE_FTP_PATH_EXT/."
997 else
998 echo -e "There was an error while uploading the iso to the ftp server."
999 exit 1
1000 fi
1001 if [ "$3" = "--with-sources-cd" ]; then
1002 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-sources-cd-$VERSION.$MACHINE.iso
1003 fi
1004 ;;
1005 paks)
1006 cat <<EOF > .ftp-commands
1007 mkdir $IPFIRE_FTP_PATH_PAK
1008 ls -lah
1009 quit
1010 EOF
1011 ncftp -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK < .ftp-commands
1012 rm -f .ftp-commands
1013 ncftpput -z -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK $IPFIRE_FTP_PATH_PAK/ packages/*
1014 if [ "$?" -eq "0" ]; then
1015 echo -e "The packages were successfully uploaded to $IPFIRE_FTP_URL_PAK$IPFIRE_FTP_PATH_PAK/."
1016 else
1017 echo -e "There was an error while uploading the packages to the ftp server."
1018 exit 1
1019 fi
1020 ;;
1021 esac
1022 ;;
1023 batch)
1024 if [ "$2" = "--background" ]; then
1025 batch_script
1026 exit $?
1027 fi
1028 if [ `screen -ls | grep -q ipfire` ]; then
1029 echo "Build is already running, sorry!"
1030 exit 1
1031 else
1032 if [ "$2" = "--rebuild" ]; then
1033 export IPFIRE_REBUILD=1
1034 echo "REBUILD!"
1035 else
1036 export IPFIRE_REBUILD=0
1037 fi
1038 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1039 screen -dmS ipfire $0 batch --background
1040 evaluate 1
1041 exit 0
1042 fi
1043 ;;
1044 watch)
1045 watch_screen
1046 ;;
1047 pxe)
1048 case "$2" in
1049 start)
1050 start_tftpd
1051 ;;
1052 stop)
1053 stop_tftpd
1054 ;;
1055 reload|restart)
1056 reload_tftpd
1057 ;;
1058 esac
1059 exit 0
1060 ;;
1061 lang)
1062 update_langs
1063 ;;
1064 "")
1065 clear
1066 svn info
1067 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1068 do
1069 case $name in
1070 "IPFIRE: Downloadsrc")
1071 $0 downloadsrc
1072 ;;
1073 "IPFIRE: Build (silent)")
1074 $0 build-silent
1075 ;;
1076 "IPFIRE: Watch Build")
1077 $0 watch
1078 ;;
1079 "IPFIRE: Batch")
1080 $0 batch
1081 ;;
1082 "IPFIRE: Clean")
1083 $0 clean
1084 ;;
1085 "SVN: Update")
1086 $0 svn update
1087 ;;
1088 "Help")
1089 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1090 cat doc/make.sh-usage
1091 ;;
1092 "LOG: Tail")
1093 tail -f log/_*
1094 ;;
1095 "Exit")
1096 break
1097 ;;
1098 esac
1099 done
1100 ;;
1101 config)
1102 make_config
1103 ;;
1104 *)
1105 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1106 cat doc/make.sh-usage
1107 ;;
1108 esac